PAGE 60,132
TITLE FTXPvt.EXE  Fidonet Technology Clear Private Flag
; ----------------------------------------------------------------------

;  Syntax      FTXPVT nnn.Msg

;   (I.P.) 1998-2001   Ben Ritchey Jr.

; Note : Place .386 here for 32-bit Segments
               DOSSEG
               .MODEL  small
               .STACK  400h    ; 1kB
; Note : Place .386 here for 16-bit Segments
               .8086           ; Base Architecture
               INCLUDE macro.inc

; ----------------------------------------------------------------------
; Un-initialized Data
               .DATA?

RECBUFF        DB      256 DUP (?)  ; Hdr Buffer
RECBL          EQU     $-RECBUFF 

               PAGE
; ----------------------------------------------------------------------
; Data Variables - 59kB Max ( 64kB - .DATA? - .STACK )
               .DATA

; PassThru Buffer Area
PASSBUFF       Label   Byte    ; PassThru Buffer
PBADDR         DD      PASSBUFF  ; Far Ptr to Here!
PBDRIVE        DB      'd:\'     ; Cur Drive
PBPATH         DB      64 DUP(0)  ; Cur Path
PBFH           DW      0       ; File Handle
PBDTA          DW      0       ; Disk Transfer Addr
PBSDTA         DW      0       ; DTA Seg

DTAFIND        DB      30 DUP (?)  ; 256 Byte DTA
DTAFSPEC       DB      226 DUP (?)  ; Offset 30=FSpec

FSPECWC        DB      64 DUP(0)

RUNDS          DW      0       ; Data Seg
RUNES          DW      0       ; Extra Seg
PSPES          DW      0       ; PSP Seg
RUNSP          DW      0       ; Stack OFFSET

INT_SEG        DW      0       ; Interrupts x1k (#x4=Addr)
BIOS_SEG       DW      40h     ; ROM Bios RAM Data
SYS_SEG        DW      0F000h  ; ROM Bios System Code
VBUF_SEG       DW      0B800h  ; Video Buffer Addr
VBUF_MODE      DB      3       ; Video Mode
RESTFLAG       DB      0
VPAGE_LEN      DW      0       ; DOS Screen Bytes

KBSTAT         DW      0       ; Kybd Stat Flag

TERMMSG        DB      13,10, 'FTXPvt terminated at '
SOTIME         DB      8 DUP (32), ', RC='
ECODE          DB      'nnn'
               DB      13, 10, '$'

CSR_LOC        Label   Word    ; Cursor Location
CSR_ROW        DB      0       ; Csr Row (0-43)
CSR_COL        DB      0       ; Csr Col (0-131)

SUP_LOC        Label   Word    ; Start-up Msg
               DB      3,0
TME_LOC        Label   Word    ; Clock
               DB      0,68
MSG_LOC        Label   Word
               DB      23,1    ; Msg Row/Col
SAV_LOC        DW      0

VERSION        DB      13,10,'FTXPvt v1.1 (c) 2001 BJr $'
DOSVER         DB      'ah.al '
LEGEND         DB      ' {IP} 1998  Ben Ritchey Jr. '
               DB      13,10,'$'

DOMSG1         DB      ' $'
DOMSG3         DB      ' ',251,'$'

ROOT           DB      'd:\',0  ; Root Path
RC             DB      0       ; Return Code
PBFSA          DW      0
PROCESS        DB      'FTXPVT.EXE',0

               PAGE
; ----------------------------------------------------------------------
; Data Constants
               .CONST

BIOSVID        EQU     10h     ; BIOS Video Int
BIOSEQU        EQU     11h     ;  "   Equipment Flags
BIOSMEM        EQU     12h     ;  "   Memory Size
BIOSDSK        EQU     13h     ;  "   Floppy Disk
BIOSCOM        EQU     14h     ;  "   Communications
BIOSEXT        EQU     15h     ;  "   Extended
BIOSKBD        EQU     16h     ;  "   Keyboard
BIOSPRT        EQU     17h     ;  "   Printer
BIOSRTC        EQU     1Ah     ;  "   Real Time Clock
DOS            EQU     21h     ; DOS Sys Func Req Int

DOTMSG         DB      '.MSG'
SYNTAX         DB      13,10,10
               DB      'Syntax is: FTXPVT.EXE {d:\Path\}nnn.MSG'
               DB      13,10,10
               DB      '           where:      {d:\Path\}nnn.MSG = INput File'
               DB      13,10
               DB      '$'
ZERO           DB      0
SPACE          DB      ' '
DOLLAR         DB      '$'

; Memory Map  ( Data Seg = .DATA + .DATA? + .STACK )
;     Seg Name :   HDR   +  PSP  +  Data  +  Code  =   Total
;    Max Alloc :    16   +  256  +  64kB  +  64kB  = 131,344
;   16 =Pages :     1   +   16  +  4096  +  4096  =   8,209
; ( also PSPSeg:0002 xWord = 1st Byte Unused RAM! )
PBPAGES        DW      8209

PATCH          DD      16 DUP(0FFh)  ; 64 Byte Patch

               PAGE
; ----------------------------------------------------------------------
; Mainline Code (Logic Stuff) - 64kB Max
               .CODE

START:         mov     ax,@data  ; Data Seg Addr
               mov     ds,ax
               mov     RUNDS,ax
               mov     es,ax     ; Extra Seg=Data
               mov     RUNES,ax

               cli             ; Stack Seg=Data (Top) 
               mov     ss,ax
               mov     sp,Offset STACK
               sti
               mov     RUNSP,sp

; Free extra RAM
               mov     ah,62h  ; Get PSP Seg
               int     DOS
               mov     PSPES,bx  ; 1st Seg/Page
               mov     es,bx

               mov     ax,RUNDS  ; Calculate ACTUAL Size  <==
               mov     bx,RUNSP  ; Convert Stack Ptr to Paras
               mov     cl,4
               shr     bx,cl   ;   to get Data + Stack (/16)
               inc     bx
               add     ax,bx   ; Add Stack Pages to DS (End of Pgm)
               mov     bx,es   ; Get Start of Program (PSP)
               sub     ax,bx   ; Subtract Start from End
               inc     ax      ; +1 for Ctl Blk
               mov     bx,ax   ; Now actual Seg/Page Size

;               mov     bx,PBPAGES  ; (to Plug Max No. Pages)
               xor     al,al
               mov     ah,4Ah  ; Re-Allocate
               int     DOS
               jnc     @F
               jmp     ERR_SET

; Verify DOS >= 5.0
@@:            @GET_VER
               cmp     al,5
               jge     @F
               mov     al,99
               mov     RC,al
               jmp     ERR_EXIT

@@:            push    ax
               mov     ZBYTE,al
               call    BIN_DEC1
               mov     ax,Word Ptr DECIMAL+6
               cmp     al,'0'
               jne     Short @F
               mov     al,'v'
@@:            mov     Word Ptr DOSVER,ax
               pop     ax
               mov     ZBYTE,ah
               call    BIN_DEC1
               mov     ax,Word Ptr DECIMAL+6
               mov     Word Ptr DOSVER+3,ax

@@:            @GET_DTA        ; PSP+80h=Cmd Args
               push    ds
               push    es
               mov     es,RUNES
               mov     di,Offset FSPECWC
               pop     ds      ; Store FSpec
               mov     si,bx
               mov     al,[si]
               cmp     al,1    ; Len=0 if No args
               jg      @F
               pop     ds      ; Restore ds!
               mov     RC,102  ; Syntax Error
               jmp     ERR_EXIT

@@:            xor     ch,ch
               mov     cl,al
               dec     cl
               inc     si
               inc     si
               cld
               rep     movsb

               add     di,1
               mov     al,"$"
               stosb

               pop     ds
               mov     dx,Offset DTAFIND  ; Private DTA
               @SET_DTA

               PAGE
; ----------------------------------------------------------------------
; Re-entrant
RESTART:       @GET_DRV        ; Cur Drive
               @GET_CDI        ; Cur Path

               mov     dx,Offset VERSION
               @PUT_STR

;      In   [ds:dx] = ASCIIZ FSpec
;           al = Access (0-Read, 1-Write, 2-R/W)
;      Out  ax = File Handle
OPENMSG:       mov     dx,Offset FSPECWC
               mov     ax,2
               mov     ah,3Dh
               int     DOS
               jnc     Short OKMSG
               jmp     ERR_SET

OKMSG:         mov     PBFH,ax

               mov     dx,Offset RECBUFF  ; Read Hdr
               mov     cx,188
               mov     bx,PBFH
               @READF

               cmp     ax,188  ; Bad Msg, skip
               je      @F
               mov     rc,13
               jmp     Short ALLDONE

@@:            xor     cx,cx   ; Rewind to TOF
               xor     dx,dx
               xor     ax,ax
               mov     bx,PBFH
               @STARTF

               and     Byte Ptr RECBUFF+186,0FEh ; PVT Flag OFF <==

               mov     dx,Offset RECBUFF  ; Write back out
               mov     cx,188
               mov     bx,PBFH
               @WRITEF

ALLDONE:       mov     bx,PBFH  ; Close File
               @CLOSEF
               mov     PBFH,0

               cmp     RC,0    ; Not cleared
               jne     Short @F
               mov     dx,Offset DOMSG1
               @PUT_STR
               mov     dx,Offset FSPECWC
               @PUT_STR
               mov     dx,Offset DOMSG3
               @PUT_STR

@@:            jmp     ERR_EXIT

               PAGE
; ----------------------------------------------------------------------
; Called Subroutines

; GET_TME  Get System Time
;  Out  BIN_TOD = Binary Time (hmsH)
;       ASC_TOD = ASCII Time (hh:mm:ss)

               .DATA
BIN_TOD        DB      4 DUP(0)  ; Binary
SYS_TOD        DD      0       ; Clicks @ 18.2/sec
ASC_TOD        DB      '00:00:00'  ; ASCII
ASC_TODL       EQU     $-ASC_TOD
MIDNIGHT       DB      ' xm',0,'$'

               .CODE
GET_TME:       call    SAVE_REGS

               mov     es,BIOS_SEG  ; store clicks (18.2/sec)
               mov     ax,word Ptr es:[6Ch]
               mov     Word Ptr SYS_TOD,ax
               mov     ax,word Ptr es:[6Eh]
               mov     es,RUNES
               mov     Word Ptr SYS_TOD+2,ax

               mov     ah,2Ch
               int     DOS       
               mov     bx,OFFSET BIN_TOD ;Save TOD
               mov     [bx],ch    ; Hour
               mov     [bx+1],cl  ; Minute
               mov     [bx+2],dh  ; Seconds
               mov     [bx+3],dl  ; Hund/Sec

               mov     ZBYTE,ch   ;Hours to ASCII
               call    BIN_DEC1
               mov     ax,WORD PTR [DECIMAL+6]
               cmp     al,'0'
               jne     Short @F
               mov     al,' '
@@:            mov     WORD PTR [ASC_TOD],ax

               mov     al,[BIN_TOD+1]  ;Minutes
               mov     ZBYTE,al
               call    BIN_DEC1
               mov     ax,WORD PTR [DECIMAL+6]
               mov     WORD PTR [ASC_TOD+3],ax

               mov     al,[BIN_TOD+2]  ;Seconds
               mov     ZBYTE,al
               call    BIN_DEC1
               mov     ax,WORD PTR [DECIMAL+6]
               mov     WORD PTR [ASC_TOD+6],ax

               mov     MIDNIGHT+1,'a'
               cmp     BIN_TOD,12
               jl      Short OKTIME
               mov     MIDNIGHT+1,'p'
               cmp     BIN_TOD,12
               je      Short OKTIME
               sub     ASC_TOD,1
               cmp     ASC_TOD+1,'2'
               jge     Short @F
               sub     ASC_TOD,1
               add     ASC_TOD+1,10

@@:            sub     ASC_TOD+1,2

OKTIME:        cmp     ASC_TOD,'0'
               jne     Short @F
               mov     ASC_TOD,' '

@@:            call    REST_REGS
               ret

; BIN_DEC1  Convert Binary to ASCII Decimal
;  In        ZBYTE = Bin Val (hh)
;  Out       DECIMAL+5 = ASCII Dec (nnn)
               .DATA
ZBYTE          DB      0
DECIMAL        DB      8 DUP('0'),0,'$'

               .CONST
HEXTABLE       DB      '0123456789ABCDEF'

               .CODE
BIN_DEC1:      call    SAVE_REGS
               xor     ax,ax
               xor     bx,bx
               mov     al,ZBYTE
               mov     cx,100  ; Hunds
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+5,al
               mov     al,ah   ; Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+6,al
               mov     bl,ah   ; Ones
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+7,al
               call    REST_REGS
               ret

; BIN_DEC2  Convert Binary to ASCII Decimal
;  In        ZWORD = Bin Val (hhhh)
;  Out       DECIMAL+3 = ASCII Dec (nnnnn)
               .DATA
ZWORD          DW      0
               .CODE
BIN_DEC2:      call    SAVE_REGS
               xor     bx,bx
               xor     dx,dx
               mov     ax,ZWORD
               mov     cx,10000  ; Ten Thous
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+3,al
               mov     ax,dx   ; Thous
               xor     dx,dx
               mov     cx,1000
               div     cx
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+4,al
               mov     ax,dx   ; Hunds
               mov     cx,100
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+5,al
               mov     al,ah   ; Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+6,al
               mov     bl,ah   ; Ones
               mov     al,HEXTABLE[bx]
               mov     DECIMAL+7,al
               call    REST_REGS
               ret

; BIN_DEC  Convert Bin RC to ASCII Decimal
;  In        RC    = Binary Value (0-255)
;  Out       ECODE = ASCII Dec (nnn)
               .CODE
BIN_DEC:       push    ax
               push    bx
               push    cx
               xor     ax,ax
               xor     bx,bx
               mov     al,RC
               mov     cx,100  ; Hunds
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     ECODE,al
               mov     al,ah   ; Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     ECODE+1,al
               mov     bl,ah   ; Ones
               mov     al,HEXTABLE[bx]
               mov     ECODE+2,al
               pop     cx
               pop     bx
               pop     ax
               ret

; SAVE_REGS / REST_REGS
;  Save/Restore ax, cx, dx, bx, bp, si, di, ds, es

               .DATA
IRADDR         DW      IRDATA  ; Next Index (+-18/36) Inc Fwd!
IRDATA         DW      252 DUP(0)  ; Reg Save Table (28 x18b @ 9r16)
               DW      0FFFFh

               .CODE
SAVE_REGS:     push    ax
               push    bx
               mov     bx,IRADDR
               cmp     Word Ptr [bx],0FFFFh
               jne     Short @F
               mov     Byte Ptr RC,95   ; Stack
               jmp     ERR_EXIT

@@:            mov     [bx],ax
               mov     [bx+2],cx
               mov     [bx+4],dx
               pop     ax         ; bx
               push    ax         ; "
               mov     [bx+6],ax  ; "
               mov     [bx+8],bp
               mov     [bx+10],si
               mov     [bx+12],di
               mov     [bx+14],ds
               mov     [bx+16],es
               add     bx,18
               mov     IRADDR,bx
               pop     bx
               pop     ax
               ret

REST_REGS:     mov     ax,Seg IRADDR
               mov     ds,ax
               mov     bx,IRADDR
               sub     bx,18
               mov     IRADDR,bx
               mov     ax,[bx]
               push    ax
               mov     Word Ptr [bx],0  ; in case FF!
               mov     cx,[bx+2]
               mov     dx,[bx+4]
               mov     bp,[bx+8]
               mov     si,[bx+10]
               mov     di,[bx+12]
               mov     ax,[bx+14]
               push    ax      ; ds
               mov     ax,[bx+16]
               mov     es,ax
               mov     ax,[bx+6]
               mov     bx,ax
               pop     ds
               pop     ax
               ret

               PAGE
; ----------------------------------------------------------------------
; Error Handler

ERR_SET:       mov     RC,al   ; Save Err #

ERR_EXIT:      mov     al,RC   ; Error #

CHKRC:         call    BIN_DEC
               cmp     RC,102
               jne     EXITP

               mov     dx,Offset SYNTAX
               @PUT_STR

; Exit to DOS
EXITP:         cmp     PBFH,0
               je      @F

               mov     bx,PBFH  ; Close File
               mov     ah,3Eh
               int     DOS       

@@:            nop
;               mov     al,PBDRIVE  ; ChDir d:\
;               mov     ROOT,al
;               mov     dx,Offset ROOT
;               @CHG_DIR

@@:            call    GET_TME  ; Stop Time
               mov     cx,4
               mov     si,Offset ASC_TOD
               mov     di,Offset SOTIME
               mov     es,RUNES
               cld
               rep     movsw

               cmp     RC,0
               je      Short @F
               mov     dx,Offset TERMMSG  ; Term Msg
               @PUT_STR

@@:            mov     al,RC   ; ErrorLevel
               mov     ah,4Ch
               int     DOS     ; Exit
               ret

               END     START   ; Start Addr!
;*** End of FTXPvt.Asm ***
